import { Node, Program, Property } from 'estel-estree-builder/generated/es2015';
import { IReduxDetails } from './redux';
export interface IReactComponent {
    componentName: string;
    definition: Node;
    props: IReactProperty[];
    redux: IReduxDetails;
}
export declare enum PropStyle {
    Input = 0,
    ReduxFunc = 1,
    State = 2
}
export interface IReactProperty {
    default: any;
    name: string;
    optional: boolean;
    style: PropStyle;
    type: string;
}
export declare type ParseResult = Program | undefined;
export interface ICachedSourceFile {
    ast: ParseResult;
    component?: IReactComponent;
    content: string;
    fileName: string;
    filePath: string;
}
export declare const extractProp: (propNode: Property, propDefaults: Map<string, string>, redux: IReduxDetails) => IReactProperty;
export declare class SourceFileCache {
    private data;
    constructor();
    getFile(filePath: string): Promise<ICachedSourceFile>;
    fileNames(): string[];
    cachedFiles(): Array<Promise<ICachedSourceFile>>;
    refresh(filePath: string): void;
    clear(filePath: string): void;
}
